module     p0_ddbar_emepg_d67h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity0/d67h0l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_config, only: ki
   use p0_ddbar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d67
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_ddbar_emepg_globalsl1, only: epspow
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_abbrevh0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb67n8+abb67n10*(spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift&
         &(2)-spvak2k5(3)*qshift(3)-spvak2k5(4)*qshift(4))+abb67n11*dotproduct(k&
         &2, qshift)+abb67n12*dotproduct(k5, qshift)+abb67n13*(spvak1k3(1)*qshif&
         &t(1)-spvak1k3(2)*qshift(2)-spvak1k3(3)*qshift(3)-spvak1k3(4)*qshift(4)&
         &)+abb67n9*(spvak4k3(1)*qshift(1)-spvak4k3(2)*qshift(2)-spvak4k3(3)*qsh&
         &ift(3)-spvak4k3(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb67n11+k5(iv1)*abb67n12+spvak1k3(iv1)*abb67n13+s&
         &pvak2k5(iv1)*abb67n10+spvak4k3(iv1)*abb67n9)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d67:
   subroutine     reconstruct_d67(coeffs)
      use p0_ddbar_emepg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_67:
      coeffs%coeffs_67%c0 = derivative(czip)
      coeffs%coeffs_67%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_67%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_67%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_67%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_67:
   end subroutine reconstruct_d67
!---#] subroutine reconstruct_d67:
end module p0_ddbar_emepg_d67h0l1d
